﻿using UnityEngine;
using System.Collections;

public class CameraShaker : MonoBehaviour 
{
	private float ShakeAmount = 0;
	private float DecreaseFactor = 0;

    private float shakeForce = 0;
	private Vector3 cameraPos;

    private IEnumerator ShakeCoroutine;

    // Use this for initialization
    void Start ()
    {
		cameraPos = transform.localPosition;
	}

	//public void Shake()
	//{
 //       if (ShakeCoroutine != null)
 //       {
 //           ShakeAmount
 //       }
 //       else
 //       {
 //           ShakeCoroutine = ShakeCam(ShakeAmount, DecreaseFactor, shakeForce);
 //           StartCoroutine(ShakeCoroutine);
 //       }
	//}

    void Update()
    {
        
        if (shakeForce > 0.0f && Time.deltaTime > 0)
        {
            // Shake the camera.
            transform.localPosition = Random.insideUnitSphere * ShakeAmount * shakeForce + cameraPos;

            // Reduce the amount of shaking for next tick.
            shakeForce -= Time.deltaTime * DecreaseFactor;

            // Check to see if we've stopped shaking.
            if (shakeForce <= 0.0f)
            {
                // Clamp the shake amount back to zero, and reset the camera position to our cached value.
                shakeForce = 0.0f;
                transform.localPosition = cameraPos;
            }
        }
        
    }

    public void Shake(float ShakeAmount, float DecreaseFactor, float shakeForce) 
    {

        /*
        //if (ShakeCoroutine != null)
        //{
            this.shakeForce = shakeForce;

            if (this.DecreaseFactor < DecreaseFactor)
            {
                this.DecreaseFactor = DecreaseFactor;
            }
            if (this.ShakeAmount < ShakeAmount)
            {
                this.ShakeAmount = ShakeAmount;
            }
        //}
        //else
        //{
        //    ShakeCoroutine = ShakeCam(ShakeAmount, DecreaseFactor, shakeForce);
        //    StartCoroutine(ShakeCoroutine);
        //}
        */

        if (this.shakeForce <= 0.0f)
        {
            this.shakeForce = shakeForce;
            this.DecreaseFactor = DecreaseFactor;
            this.ShakeAmount = ShakeAmount;
        }
        else
        {
            this.shakeForce = shakeForce;
            if (this.DecreaseFactor < DecreaseFactor)
            {
                this.DecreaseFactor = DecreaseFactor;
            }
            if (this.ShakeAmount < ShakeAmount)
            {
                this.ShakeAmount = ShakeAmount;
            }
        }
    }

    private IEnumerator ShakeCam(float ShakeAmount, float DecreaseFactor, float shakeForce)
	{
		
		// Check if the screen should be shaking.
		while (shakeForce > 0.0f && Time.deltaTime>0) 
		{
			// Shake the camera.
			transform.localPosition = Random.insideUnitSphere * ShakeAmount * shakeForce + cameraPos;

            // Reduce the amount of shaking for next tick.
            shakeForce -= Time.deltaTime * DecreaseFactor;
			
			// Check to see if we've stopped shaking.
			if (shakeForce <= 0.0f)
			{
                // Clamp the shake amount back to zero, and reset the camera position to our cached value.
                shakeForce = 0.0f;
				transform.localPosition = cameraPos;
			}
			yield return null;
		}
	}
}
